#ifndef __PMsg_p__HPP
#define __PMsg_p__HPP

#include "mpi.h"
#include <vector>
#include <string>
using namespace std;

//==============================================================================

// A GREATLY simplified and restricted version of the full PMsg_p class (which
// derives from the Msg_p general message-packing-and-unpacking class) that
// includes only basic send-receive functionality and a static typemap composed
// of a single integer and 2 strings.

//------------------------------------------------------------------------------
class PMsg_p {
public :
                        PMsg_p(MPI_Comm c=MPI_COMM_NULL);
                        PMsg_p(unsigned char * pb,int l,MPI_Comm c=MPI_COMM_NULL);
                        PMsg_p(PMsg_p & r);
virtual ~               PMsg_p(void);
void                    Bcast();
void                    Clear();
int *                   Get(int);
void                    Get(int,string &);  // SAME ADR SPC AS CHAR
unsigned                Key();
void                    Key(unsigned char,unsigned char=0x00,unsigned char=0x00,unsigned char=0x00);
static unsigned         KEY(unsigned char=0x00,unsigned char=0x00,unsigned char=0x00,unsigned char=0x00);
int                     Length();
void                    Load(unsigned char *,int);
void                    Put(int,int);
void                    Put(int,string *);   // SAME ADR SPC AS CHAR
void                    Send();
void                    Send(int);
inline int              Src() {return src;};
inline void             Src(int s) {src = s;};
unsigned char *         Stream();
inline void             Tag(int g) {tag = g;};
inline int              Tag() {return tag;};
inline int              Tgt() {return tgt;};
inline void             Tgt(int t) {tgt = t;};

MPI_Comm                comm;

static const unsigned   Z_FIELDS = 4;  // Number of identifier fields
static const unsigned   BITSPERBYTE = 4;
  
private:

void                    pullB(int &, int &);
void                    pullB(int &, unsigned int &);
void                    pullB(int &, string &);
inline void             pullB(int & nfc, unsigned char & uc) {uc = vm[nfc++];};
void                    pushB(vector<unsigned char> &, int);
void                    pushB(vector<unsigned char> &, unsigned);
void                    pushB(vector<unsigned char>&, char);
inline void             pushB(vector<unsigned char> & v, unsigned char x) {v.push_back(x);};

struct Msg_p_t
{
           Msg_p_t();
  int      data0;                     // An integer value
  string   data1;                     // First string
  string   data2;                     // Second string
} M;

vector<unsigned char> vm;             // Packed message
  
unsigned char         subkey[Z_FIELDS];// Identifier fields
int                   src;             // Source ID
int                   tgt;             // Target ID
int                   tag;             // Message tag
  
};

//==============================================================================

#endif

