//------------------------------------------------------------------------------

#include "ProcMap.h"
#include "CommonBase.h"
#include "Pglobals.h"

//==============================================================================

ProcMap::ProcMap(CommonBase * p)
{
par = p;                               // Who owns me?
M[Q::NAP] = string(csNOTaPROCproc);    // The name of the Unknown Process
}

//------------------------------------------------------------------------------

ProcMap::~ProcMap()
{
//printf("********* ProcMap rank %d destructor\n",par->Urank); fflush(stdout);
}

//------------------------------------------------------------------------------

void ProcMap::GetProcs(vector<ProcMap_t> & vs)
// Load the argument vector with the list of current process main class names
{
vs = vPmap;
}

//------------------------------------------------------------------------------

void ProcMap::Register(PMsg_p * Z)
// Load a single record into the map
{
ProcMap_t rec;                         // Create the record
                                       // Unload the message
int * pi = Z->Get(0);                  // ... rank
if (pi!=0) rec.P_rank = *pi;
Z->Get(1,rec.P_proc);                  // ... machine name
Z->Get(2,rec.P_class);                 // ... C++ class

vPmap.push_back(rec);                  // Load the map
M[rec.P_rank] = rec.P_class;           // ...and the process ranks
}

//==============================================================================

ProcMap::ProcMap_t::ProcMap_t()
// Defined 'horrible' values, all of which should be overwritten in normal use
{
P_rank  = Q::NAP;                      // Process rank
P_proc = string(csNOTaPROCproc);       // Process name
P_class = "";
}

//==============================================================================


